﻿using Microsoft.AspNetCore.Authorization;
using System;
using System.Linq;
using System.Threading.Tasks;

namespace Benday.AspNetCore.SecuritySample.WebUi.Security
{
    public class EditLibraryEntryHandler : AuthorizationHandler<EditLibraryEntryRequirement>
    {
        /*
        protected override void Handle(AuthorizationContext context, AdminRoleRequirement requirement)
        {
            if (context.User.HasClaim("Demo.Fluffy", "true") == true)
            {
                context.Succeed(requirement);
            }
            else
            {
                return;
            }
        }
        */
        protected override Task HandleRequirementAsync(
            AuthorizationHandlerContext context,
            EditLibraryEntryRequirement requirement)
        {
            if (context.Resource is Microsoft.AspNetCore.Mvc.Filters.AuthorizationFilterContext mvcContext)
            {
                if (mvcContext.RouteData.Values.ContainsKey("id") == false)
                {
                    context.Fail();
                }
                else
                {
                    int id = Convert.ToInt32(mvcContext.RouteData.Values["id"]);

                    var utility = new SecurityUtility(context.User.Identity, context.User);

                    if (utility.IsAuthorized(SecurityConstants.PermissionName_Edit, id) == true)
                    {
                        context.Succeed(requirement);
                    }
                    else
                    {
                        context.Fail();
                    }
                }
            }
            else
            {
                context.Fail();
            }


            return Task.CompletedTask;
        }
    }
}
