﻿using Benday.RightsBasedSecurity.Core.AspNetSecurity;
using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Data.Entity.ModelConfiguration.Conventions;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Benday.RightsBasedSecurity.Core
{
    public class SecurityDbContext : DbContext
    {

        public SecurityDbContext() : base("name=(default)")
        {
            
        }

        protected SecurityDbContext(string connectionString) :
            base(connectionString)
        {

        }

        public IDbSet<AspNetUserClaim> AspNetUserClaims { get; set; }
        public IDbSet<AspNetUserLogin> AspNetUserLogins { get; set; }
        public IDbSet<AspNetRole> AspNetRoles { get; set; }
        public IDbSet<AspNetUser> AspNetUsers { get; set; }
        public IDbSet<AspNetUserRole> AspNetUserRoles { get; set; }

        public IDbSet<ItemGroup> ItemGroups { get; set; }
        public IDbSet<ItemGroupMember> ItemGroupMembers { get; set; }
        public IDbSet<ItemType> ItemTypes { get; set; }
        public IDbSet<ItemRight> ItemRights { get; set; }
        public IDbSet<RightGrant> RightGrants { get; set; }
        public IDbSet<UserGroup> UserGroups { get; set; }
        public IDbSet<UserGroupMember> UserGroupMembers { get; set; }
        public IDbSet<UserLogin> UserLogins { get; set; }

        protected override void OnModelCreating(DbModelBuilder modelBuilder)
        {
            // modelBuilder.Conventions.Remove<PluralizingTableNameConvention>();
            modelBuilder.Entity<AspNetUserRole>().HasKey(x => new { x.RoleId, x.UserId });
            modelBuilder.Entity<AspNetUserLogin>().HasKey(x => 
            new { x.LoginProvider, x.ProviderKey, x.UserId});
        }

        public System.Data.Entity.DbSet<Benday.RightsBasedSecurity.Core.LibraryEntry> LibraryEntries { get; set; }
    }
}
